# frozen_string_literal: true

require "normalize_url"

module Wayfarer
  module Frontiers
    # @api private
    module NormalizeURIs
      # @override
      def stage(*uris)
        super(*uris.map { |uri| normalize(uri) })
      end

      # @override
      def staged?(uri)
        super(normalize(uri))
      end

      # @override
      def cache(*uris)
        super(*uris.map { |uri| normalize(uri) })
      end

      # @override
      def cached?(uri)
        super(normalize(uri))
      end

      private

      def normalize(uri)
        NormalizeUrl.process(uri, config.normalize_uri_options)
      end

      def to_s
        "URI-normalizing #{super}"
      end

      def method_missing(*argv, &proc)
        super(*argv, &proc)
      end

      def respond_to_missing?(method, private = false)
        @frontier.respond_to?(method) || super
      end
    end
  end
end
