# frozen_string_literal: true

require "uri"

module Wayfarer
  module Routing
    # @private
    class CustomRule < Rule
      def initialize(delegate_or_block = proc, opts = {}, &proc)
        @delegate_or_block = delegate_or_block
        super(opts, &proc)
      end

      private

      def match!(uri)
        !!@delegate_or_block.call(uri)
      end
    end
  end
end
